---
layout: book
section: documentation
category: manual
title: Usage
permalink: /docs/manual/usage
---
After TileMill is installed you will want to familiarize yourself with the basics of starting and stopping the app as well as configuring any relevant settings.

## Mac OS X

TileMill for Mac OS X is meant to be run as a desktop-style application.

- **Start** TileMill by double-clicking its icon in the `Applications` folder
- **Stop** TileMill by quitting the application
- **Files** used by TileMill are in your user account's `Documents/MapBox` folder
- **Logs** are viewable by choosing `Console` from the app's `Window` menu
- **Preferences** are available from the `TileMill` menu. 

## Ubuntu

TileMill on Ubuntu may be run as a system-wide service, or from the Desktop.

### Desktop usage

Start TileMill from the Desktop with the TileMill menu item, located in the `Graphics` section in the Applications menu, or using the Launcher.  When TileMill launches a terminal window will open; this window must stay open to keep TileMill running.  After starting TileMill from the menu, go to `http://localhost:8889` to access TileMill.

Upon first start of TileMill from the Desktop, a configuration file will be created at `~/.tilemill.json` which can be customized to, for example, change the default port on which TileMill runs.  TileMill will write to a log file at `~/.tilemill.log`.  TileMill also creats a directory at `~/Documents/MapBox` which holds data and project files.

### System-wide usage

TileMill on Ubuntu runs as a server and is kept up and running by `upstart`. TileMill as a system-wide service is not running by default.

- **Start** TileMill by running `sudo start tilemill`
- **Stop** TileMill by running `sudo stop tilemill`
- **Restart** TileMill by running `sudo restart tilemill`
- **Files** used by TileMill are in `/usr/share/mapbox`
- **Logs** are written to `/var/log/tilemill`

Once TileMill has been started you can access the interface in your web browser at `http://localhost:8889`.

You can alter the server settings of TileMill by editing the configuration file at `/etc/tilemill/tilemill.config`. The configuration file should contain a JSON object:

    {
      "port": 3001,
      "files": "/home/ubuntu/mapbox"
    }

- `port` the port that the server should listen on. Defaults to `8889`
- `host` a single or array of hostnames that can be used to connect to the server. Defaults to `localhost`
- `files` path to the files directory. Defaults to `/usr/share/mapbox`

